# coding: utf-8

"""
  Copyright 2024 Amazon.com, Inc. or its affiliates. All Rights Reserved.

  Licensed under the Apache License, Version 2.0 (the "License").
  You may not use this file except in compliance with the License.
  A copy of the License is located at

      http://www.apache.org/licenses/LICENSE-2.0

  or in the "license" file accompanying this file. This file is distributed
  on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
  express or implied. See the License for the specific language governing
  permissions and limitations under the License.
"""


"""
    ProductAdvertisingAPI

    https://webservices.amazon.com/paapi5/documentation/index.html  # noqa: E501
"""


import pprint
import re  # noqa: F401

import six

from paapi5_python_sdk.models.offer_condition import OfferCondition  # noqa: F401,E501
from paapi5_python_sdk.models.offer_price import OfferPrice  # noqa: F401,E501


class OfferSummary(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'condition': 'OfferCondition',
        'highest_price': 'OfferPrice',
        'lowest_price': 'OfferPrice',
        'offer_count': 'int'
    }

    attribute_map = {
        'condition': 'Condition',
        'highest_price': 'HighestPrice',
        'lowest_price': 'LowestPrice',
        'offer_count': 'OfferCount'
    }

    def __init__(self, condition=None, highest_price=None, lowest_price=None, offer_count=None):  # noqa: E501
        """OfferSummary - a model defined in Swagger"""  # noqa: E501

        self._condition = None
        self._highest_price = None
        self._lowest_price = None
        self._offer_count = None
        self.discriminator = None

        if condition is not None:
            self.condition = condition
        if highest_price is not None:
            self.highest_price = highest_price
        if lowest_price is not None:
            self.lowest_price = lowest_price
        if offer_count is not None:
            self.offer_count = offer_count

    @property
    def condition(self):
        """Gets the condition of this OfferSummary.  # noqa: E501


        :return: The condition of this OfferSummary.  # noqa: E501
        :rtype: OfferCondition
        """
        return self._condition

    @condition.setter
    def condition(self, condition):
        """Sets the condition of this OfferSummary.


        :param condition: The condition of this OfferSummary.  # noqa: E501
        :type: OfferCondition
        """

        self._condition = condition

    @property
    def highest_price(self):
        """Gets the highest_price of this OfferSummary.  # noqa: E501


        :return: The highest_price of this OfferSummary.  # noqa: E501
        :rtype: OfferPrice
        """
        return self._highest_price

    @highest_price.setter
    def highest_price(self, highest_price):
        """Sets the highest_price of this OfferSummary.


        :param highest_price: The highest_price of this OfferSummary.  # noqa: E501
        :type: OfferPrice
        """

        self._highest_price = highest_price

    @property
    def lowest_price(self):
        """Gets the lowest_price of this OfferSummary.  # noqa: E501


        :return: The lowest_price of this OfferSummary.  # noqa: E501
        :rtype: OfferPrice
        """
        return self._lowest_price

    @lowest_price.setter
    def lowest_price(self, lowest_price):
        """Sets the lowest_price of this OfferSummary.


        :param lowest_price: The lowest_price of this OfferSummary.  # noqa: E501
        :type: OfferPrice
        """

        self._lowest_price = lowest_price

    @property
    def offer_count(self):
        """Gets the offer_count of this OfferSummary.  # noqa: E501


        :return: The offer_count of this OfferSummary.  # noqa: E501
        :rtype: int
        """
        return self._offer_count

    @offer_count.setter
    def offer_count(self, offer_count):
        """Sets the offer_count of this OfferSummary.


        :param offer_count: The offer_count of this OfferSummary.  # noqa: E501
        :type: int
        """

        self._offer_count = offer_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OfferSummary, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OfferSummary):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
